WinStd Windows Win32 API using Standard C++

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
winstd::vmemory Class Reference
Windows API

Memory in virtual address space of a process handle wrapper. More...

`#include <WinStd/Win.h>`

Inheritance diagram for winstd::vmemory:

## Public Member Functions
| vmemory () noexcept
| Initializes a new class instance with the memory handle set to INVAL.
| vmemory (handle_type h, HANDLE proc) noexcept
| Initializes a new class instance with an already available object handle.
| vmemory (vmemory &&h) noexcept
| Move constructor.
virtual | ~vmemory ()
| Frees the memory.
vmemory & | operator= (vmemory &&other) noexcept
| Move assignment.
void | attach (HANDLE proc, handle_type h) noexcept
| Sets a new memory handle for the class.
bool | alloc (HANDLE hProcess, LPVOID lpAddress, SIZE_T dwSize, DWORD flAllocationType, DWORD flProtect) noexcept
| Reserves, commits, or changes the state of a region of memory within the virtual address space of a specified process. The function initializes the memory it allocates to zero.
Public Member Functions inherited from winstd::handle< LPVOID, NULL >
| handle () noexcept
| Initializes a new class instance with the object handle set to INVAL.
| handle (handle_type h) noexcept
| Initializes a new class instance with an already available object handle.
| handle (handle< handle_type, INVAL > &&h) noexcept
| Move constructor.
handle< handle_type, INVAL > & | operator= (handle_type h) noexcept
| Attaches already available object handle.
handle< handle_type, INVAL > & | operator= (handle< handle_type, INVAL > &&h) noexcept
| Move assignment.
| operator handle_type () const
| Auto-typecasting operator.
handle_type *& | operator* () const
| Returns the object handle value when the object handle is a pointer to a value (class, struct, etc.).
handle_type * | operator& ()
| Returns the object handle reference.
handle_type | operator-> () const
| Provides object handle member access when the object handle is a pointer to a class or struct.
bool | operator! () const
| Tests if the object handle is invalid.
bool | operator< (handle_type h) const
| Is handle less than?
bool | operator<= (handle_type h) const
| Is handle less than or equal to?
bool | operator>= (handle_type h) const
| Is handle greater than or equal to?
bool | operator> (handle_type h) const
| Is handle greater than?
bool | operator!= (handle_type h) const
| Is handle not equal to?
bool | operator== (handle_type h) const
| Is handle equal to?
void | attach (handle_type h) noexcept
| Sets a new object handle for the class.
handle_type | detach ()
| Dismisses the object handle from this class.
void | free ()
| Destroys the object.

## Protected Member Functions
void | free_internal () noexcept override
| Frees the memory.

## Protected Attributes
HANDLE | m_proc
| Handle of memory's process.
Protected Attributes inherited from winstd::handle< LPVOID, NULL >
handle_type | m_h
| Object handle.

## Additional Inherited Members
Public Types inherited from winstd::handle< LPVOID, NULL >
typedef LPVOID | handle_type
| Datatype of the object handle this template class handles.
Static Public Attributes inherited from winstd::handle< LPVOID, NULL >
static const LPVOID | invalid
| Invalid handle value.

## Detailed Description

Memory in virtual address space of a process handle wrapper.

## Constructor & Destructor Documentation

## ◆ vmemory() [1/2]

winstd::vmemory::vmemory | ( | handle_type | h,
|  | HANDLE | proc )
| inline noexcept

Initializes a new class instance with an already available object handle.

Parameters

  [in] | proc | Handle of process the memory belongs to
  [in] | h | Initial object handle value

## ◆ vmemory() [2/2]

winstd::vmemory::vmemory | ( | vmemory && | h | ) |
| inline noexcept

Move constructor.

Parameters

  [in,out] | h | A rvalue reference of another object

## ◆ ~vmemory()

virtual winstd::vmemory::~vmemory | ( |  | ) |
| inline virtual

Frees the memory.

See also
  VirtualFreeEx function

## Member Function Documentation

## ◆ alloc()

bool winstd::vmemory::alloc | ( | HANDLE | hProcess,
|  | LPVOID | lpAddress,
|  | SIZE_T | dwSize,
|  | DWORD | flAllocationType,
|  | DWORD | flProtect )
| inline noexcept

Reserves, commits, or changes the state of a region of memory within the virtual address space of a specified process. The function initializes the memory it allocates to zero.

See also
  VirtualAllocEx function

Returns
  - `true` when succeeds;
  - `false` when fails. Use `GetLastError()` for failure reason.

## ◆ attach()

void winstd::vmemory::attach | ( | HANDLE | proc,
|  | handle_type | h )
| inline noexcept

Sets a new memory handle for the class.

When the current object handle of the class is non-INVAL, the object is destroyed first.

Parameters

  [in] | proc | Handle of process the memory belongs to
  [in] | h | Initial object handle value

## ◆ free_internal()

void winstd::vmemory::free_internal | ( |  | ) |
| inline override protected virtual noexcept

Frees the memory.

See also
  VirtualFreeEx function

Implements winstd::handle< LPVOID, NULL >.

## ◆ operator=()

vmemory & winstd::vmemory::operator= | ( | vmemory && | other | ) |
| inline noexcept

Move assignment.

Parameters

  [in,out] | other | A rvalue reference of another object

The documentation for this class was generated from the following file:

- include/WinStd/Win.h